//define used headers and stuff
#pragma hdrstop
#include <windows.h>
#include <condefs.h>
#include "classes.h"
#include "winsock.h"
#include "zoiff.h"
#include "graphics.h"
#include "fstream.h"
#include "process.h"

USEUNIT("graphics.cpp");
USEUNIT("classes.cpp");

void sendloop(void *thread);
HDC maindc;
HPEN pen1=NULL;
HPEN pen2=NULL;
int flicker=0;
SIZE radarsize;
SIZE radarspot;
SIZE *size=new SIZE;
HBITMAP radar;
HPALETTE radarpal;
HWND radio[5];
HWND talkbuttn;
void saystuff(void *thread);
bool chatrequest=false;
char *bmpfiles[5]={"images\\sprites\\NESS.bmp","images\\sprites\\PAULA.bmp","images\\sprites\\JEFF.bmp","images\\sprites\\POO.bmp","images\\sprites\\NESSPJ.bmp"};
//---------------------------------------------------------------------------
#pragma argsused

//start WinMain function
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int nCmdShow)
{
 maininst=hInstance;

 //setting up main Window Class
 wc.style = CS_HREDRAW | CS_VREDRAW| CS_OWNDC;
 wc.cbClsExtra = 0;
 wc.cbWndExtra = 0;
 wc.hbrBackground = (HBRUSH)(COLOR_WINDOW);
 wc.hCursor = LoadCursor( NULL, IDC_ARROW );
 wc.hIcon =NULL;// LoadIcon(NULL,NULL);
 wc.hInstance = hInstance;
 wc.lpfnWndProc = (WNDPROC)WindowProc;
 wc.lpszMenuName = NULL;
 wc.lpszClassName = "ZoiffWindow";

 //regestering window class
 if (RegisterClass(&wc)==0)
   return 1;

 //Creating actual window to be a basic window which stays-on-top
  hWnd=CreateWindow("ZoiffWindow",
     "Earthbound Seek and Tag",
     WS_BORDER|WS_POPUP|WS_OVERLAPPED|WS_CAPTION,
     0,0,
     640, 480,
     NULL,
     NULL,
     hInstance,
     NULL);

  if(hWnd==NULL)
  {
   MessageBox(NULL, "Could not set up window correctly!", "Error on CreateWindow()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
   quitting();
   return NULL;
  }

 char *yourname=new char[200];
 strcpy(yourname,"Anonymous");
 ifstream *ifs=new ifstream("seektag.ini",ios::in|ios::binary);
  if(*ifs)
  {
   BYTE numofletters;
   ifs->read((char*)&numofletters,1);
   ifs->read(yourname,numofletters);
   yourname[numofletters]='\0';
   ifs->close();
  }
 delete ifs;
edit1=CreateWindow("EDIT","127.0.0.1",WS_CHILD|WS_BORDER|WS_VISIBLE,0,380,550,19,hWnd,NULL,hInstance,NULL);
memo2=CreateWindow("EDIT",yourname,WS_CHILD|WS_BORDER|WS_VISIBLE,0,400,600,18,hWnd,NULL,hInstance,NULL);
memo1=CreateWindow("EDIT","Not connected",WS_CHILD|WS_BORDER|ES_READONLY|WS_VISIBLE,0,417,600,18,hWnd,NULL,hInstance,NULL);
memo3=CreateWindow("EDIT","",WS_CHILD|ES_AUTOHSCROLL|WS_BORDER|WS_VISIBLE,0,434,550,18,hWnd,NULL,hInstance,NULL);
gobuttn=CreateWindow("BUTTON","Go!",WS_CHILD|WS_BORDER|WS_VISIBLE,555,381,75,19,hWnd,NULL,hInstance,NULL);
talkbuttn=CreateWindow("BUTTON","Say",WS_CHILD|WS_BORDER|WS_VISIBLE,555,434,75,19,hWnd,NULL,hInstance,NULL);

radio[0]=CreateWindow("BUTTON","Ness",WS_CHILD|BS_AUTORADIOBUTTON|WS_VISIBLE,0,359,75,21,hWnd,NULL,hInstance,NULL);
radio[1]=CreateWindow("BUTTON","Paula",WS_CHILD|BS_AUTORADIOBUTTON|WS_VISIBLE,75,359,75,21,hWnd,NULL,hInstance,NULL);
radio[2]=CreateWindow("BUTTON","Jeff",WS_CHILD|BS_AUTORADIOBUTTON|WS_VISIBLE,150,359,75,21,hWnd,NULL,hInstance,NULL);
radio[3]=CreateWindow("BUTTON","Poo",WS_CHILD|BS_AUTORADIOBUTTON|WS_VISIBLE,225,359,75,21,hWnd,NULL,hInstance,NULL);
radio[4]=CreateWindow("BUTTON","Ness(PJs)",WS_CHILD|BS_AUTORADIOBUTTON|WS_VISIBLE,300,359,100,21,hWnd,NULL,hInstance,NULL);
maindc=GetDC(hWnd);

if(maindc==NULL)
{
 MessageBox(NULL, "Error with Graphics setup!", "Error on GetDC()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
}
SendMessage(memo3,EM_SETLIMITTEXT,150,0);
//Call initialize() function, set game timer event, show window
Initialize();


/*char *buf=new char[25];
itoa(joe,buf,10);
SetWindowText(hWnd,buf);
delete buf;
*/

ShowWindow(hWnd,nCmdShow);

pen1=CreatePen(PS_SOLID,2,RGB(0,0,255));
pen2=CreatePen(PS_SOLID,2,RGB(0,255,0));

   MSG msg;
   while(GetMessage(&msg,NULL,0,0))
   {
     if(msg.hwnd==memo3)
     {
      if(msg.message==WM_KEYDOWN)
      {
       if(msg.wParam==13){if(connected)chatrequest=true;SetFocus(hWnd);}
      }
     }
    TranslateMessage(&msg);
    DispatchMessage(&msg);
    //if(msg.message==NULL)heartbeat();
   }
}

LRESULT WindowProc(HWND hwnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
 switch(wMsg)
 {
  case WM_COMMAND:
  {

   if(lParam==(LPARAM)talkbuttn)
   {
    if(connected)
    {
    chatrequest=true;
    SetFocus(hWnd);
    }
   }
   if(lParam==(LPARAM)gobuttn)
   {
    if(!connected)
    {
     if(heros[selectednum].mapindex!=0)readinlvl(indexofmaps[0]);
    ofstream ofs("seektag.ini",ios::out|ios::binary);
    if(ofs)
    {
    char *tempstr=new char[200];
    int leng=GetWindowText(memo2,tempstr,150);
    tempstr[leng]='\0';
     ofs.write((char*)&leng,1);
     ofs.write(tempstr,leng);
     ofs.close();
    }
    DeleteObject(title);
    timerset=true;
    SetTimer(hWnd,1,40,NULL);
    SetTimer(hWnd,2,80,NULL);
    SetFocus(hWnd);
    connect();
    }
   }
  break;
  }
  case WM_LBUTTONDOWN:
  {
  SetFocus(hWnd);
  break;
  }
  case WM_TIMER:
  {
   if(wParam==1)
   {
    flicker++;
    heartbeat();
   }
/*   if(wParam==2)
   {
    if(connected)_beginthread(sendinfo,NULL,NULL);
   }*/
  break;
  }
  case WM_KEYUP:
  {
  keys[wParam]=false;
  break;
  }
  case WM_KEYDOWN:
  {
  keys[wParam]=true;
  if(wParam==13)SetFocus(memo3);
  if(wParam==32)  //if shooting
  {
   if((connected)&&(IT==selectednum))
   {
//    _beginthread(shootpsi,0,NULL);
 PSIrequest=true;
   }
  }

  if(wParam==27)   //if esc is hit, close
   {
    if(connected){connected=false;closesocket(sock);}
    quitting();
   }
  break;
  }
  case WM_CLOSE:
  {
   if(connected){connected=false;closesocket(sock);}
   quitting();
   break;
  }
 case WM_PAINT:
 {
  if(!timerset)  //if wanting to paint and not playing, draw title
  {
  HDC other=CreateCompatibleDC(maindc);
  SelectObject(other,title);
  BitBlt(maindc,0,0,640,380,other,0,0,SRCCOPY);
  DeleteDC(other);
  }
 }

 default: return DefWindowProc(hwnd, wMsg, wParam, lParam);  //the default windows proc
 }
}

void quitting(void)  //cleanup procedure
{
 ReleaseDC(hWnd,maindc);
 WSACleanup();
 KillTimer(hWnd,1);
 PostQuitMessage(0);
}

void Initialize(void)  //Call to initialize, it clears all arrays and stuff
{
// ShowCursor(false);
for(int n=0;n<4;n++)
{
strings[n][0]='\0';
strings[n][1]='\0';
}
SendMessage(radio[0],BM_SETCHECK,BST_CHECKED,0);
radar=LoadDDB("images\\sprites\\RADAR.bmp",maindc,&radarpal,size);
if(radar==NULL){  MessageBox(NULL, "Could not find a .bmp file!  Make sure this was installed correctly.", "Graphics error", MB_OK|MB_APPLMODAL|MB_TOPMOST); quitting(); exit(0);}
title=LoadDDB("seektag.bmp",maindc,&titlepal,size);
if(title==NULL){  MessageBox(NULL, "Could not find a .bmp file!  Make sure this was installed correctly.", "Graphics error", MB_OK|MB_APPLMODAL|MB_TOPMOST); quitting(); exit(0);}
WSADATA wsadata;
 if(WSAStartup(MAKEWORD(1,1),&wsadata)!=0)
 {
  MessageBox(NULL, "Big fat winsock error!!!", "Error on WSAStartup()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
  quitting();
  exit(0);
 }

selectednum=0;
// delete device;
  for(int n=0;n<15;n++)
  {
   heros[n].name=new char[25];
   heros[n].exists=false;
   heros[n].x=0;
   heros[n].y=0;
   heros[n].width=32;
   heros[n].height=48;
   heros[n].dir=DIR_DOWN;
   heros[n].speed=7;
   heros[n].stepcur=0;
   heros[n].stepnum=3;
   heros[n].chosenchar=1;
   heros[n].pict=LoadDDB("images\\sprites\\ness.bmp",maindc,&heros[n].hpal,size);
   if(heros[n].pict==NULL){  MessageBox(NULL, "Could not find a .bmp file!  Make sure this was installed correctly.", "Graphics error", MB_OK|MB_APPLMODAL|MB_TOPMOST); quitting(); exit(0);}
  }

  for(int n=0;n<3;n++)
  {
   shots[n].name="";
   shots[n].x=50;
   shots[n].width=34;
   shots[n].height=34;
   shots[n].y=50;
   shots[n].dir=2;
   shots[n].stepcur=0;
   shots[n].stepnum=0;
   shots[n].exists=false;
   shots[n].stepping=false;
   shots[n].pict=LoadDDB("images\\sprites\\psi.bmp",maindc,&shots[n].hpal,size);
   if(shots[n].pict==NULL){  MessageBox(NULL, "Could not find a .bmp file!  Make sure this was installed correctly.", "Graphics error", MB_OK|MB_APPLMODAL|MB_TOPMOST); quitting(); exit(0);}
  }

  strcpy(heros[0].name,"Ness");
 heros[selectednum].exists=true;
 if(heros[selectednum].pict==NULL)
 {
  MessageBox(hWnd,"Could not find a .bmp.  Please be sure this was installed correctly.","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
  quitting();
  exit(0);
 }

 if(readinlvl(indexofmaps[0])!=0)
  {
  MessageBox(hWnd,"Could not find a map or error reading in file.  Please be sure this was unzipped correctly.","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
  quitting();
  exit(0);
  }

 int joebob=0;
 for(int n=0;n<numofblocks;n++)
 {
  joebob=joebob+blocks[n].x;
 }

if(numofblocks!=64)
{
 MessageBox(hWnd,"Error in main.lvl.  You weren't messing in it, were you?","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
 quitting();
 exit(0);
}


if(joebob!=49534)
{
 MessageBox(hWnd,"Error in main.lvl.  You weren't messing in it, were you?","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
 quitting();
 exit(0);
}

 heros[selectednum].speed=7;
 heros[selectednum].stepcur=0;
 heros[selectednum].stepnum=3;
 heros[selectednum].x=350;
 heros[selectednum].y=200;
 heros[selectednum].width=32;
 heros[selectednum].height=48;
 camx=heros[selectednum].x-310;
 camy=heros[selectednum].y-200;

 PlaySound("sounds\\Music.wav",NULL,SND_FILENAME|SND_ASYNC);
}

void heartbeat(void)  //done every timer tick.
{

//checks if any of the keys[] are true
  if(keys[40]){heros[selectednum].dir=DIR_DOWN;}
  if(keys[39]){heros[selectednum].dir=DIR_RIGHT;}
  if(keys[37]){heros[selectednum].dir=DIR_LEFT;}
  if(keys[38]){heros[selectednum].dir=DIR_UP;}
  if(keys[40]&&keys[37]){heros[selectednum].dir=DIR_DOWNLEFT;}
  if(keys[40]&&keys[39]){heros[selectednum].dir=DIR_DOWNRIGHT;}
  if(keys[38]&&keys[39]){heros[selectednum].dir=DIR_UPRIGHT;}
  if(keys[38]&&keys[37]){heros[selectednum].dir=DIR_UPLEFT;}

  bool testmove[4]={true,true,true,true};
  bool *tempmove;
int ax=-1;
int ay=-1;
int aw=-1;
int ah=-1;
  for(int n=0;n<numofblocks;n++)
  {
   if((heros[selectednum].x+heros[selectednum].width+(blocks[n].height*2)>=blocks[n].x)&&(heros[selectednum].x-(2*blocks[n].height)<blocks[n].x+blocks[n].width))
   {
    tempmove=blocks[n].checkhit(&heros[selectednum]);
    if(!tempmove[0]){testmove[0]=false;if(blocks[n].type==1)ah=blocks[n].y+blocks[n].height-heros[selectednum].height+1;}
    if(!tempmove[1]){testmove[1]=false;if(blocks[n].type==1)ay=blocks[n].y-heros[selectednum].height-1;}
    if(!tempmove[2]){testmove[2]=false;if(blocks[n].type==1)aw=blocks[n].x+blocks[n].width+1;}
    if(!tempmove[3]){testmove[3]=false;if(blocks[n].type==1)ax=blocks[n].x-heros[selectednum].width-1;}
   }
  }

  if(((heros[selectednum].dir==DIR_DOWN)||(heros[selectednum].dir==DIR_DOWNLEFT)||(heros[selectednum].dir==DIR_DOWNRIGHT))&&(testmove[1]==true)&&(heros[selectednum].walking)&&(heros[selectednum].y+heros[selectednum].height+heros[selectednum].speed<levlsize.cy)){heros[selectednum].y+=heros[selectednum].speed;if((camy<levlsize.cy-380-heros[selectednum].speed)&&(heros[selectednum].y-camy>210))camy+=heros[selectednum].speed;}
  if(((heros[selectednum].dir==DIR_RIGHT)||(heros[selectednum].dir==DIR_DOWNRIGHT)||(heros[selectednum].dir==DIR_UPRIGHT))&&(testmove[3]==true)&&(heros[selectednum].walking)&&(heros[selectednum].x+heros[selectednum].width+heros[selectednum].speed<levlsize.cx)){heros[selectednum].x+=heros[selectednum].speed;if((camx<levlsize.cx-640-heros[selectednum].speed)&&(heros[selectednum].x-camx+heros[selectednum].speed>380))camx+=heros[selectednum].speed;}
  if(((heros[selectednum].dir==DIR_LEFT)||(heros[selectednum].dir==DIR_DOWNLEFT)||(heros[selectednum].dir==DIR_UPLEFT))&&(testmove[2]==true)&&(heros[selectednum].walking)&&(heros[selectednum].x-heros[selectednum].speed>0)){heros[selectednum].x-=heros[selectednum].speed;if((camx-heros[selectednum].speed>0)&&(heros[selectednum].x-camx<280))camx-=heros[selectednum].speed;}
  if(((heros[selectednum].dir==DIR_UP)||(heros[selectednum].dir==DIR_UPLEFT)||(heros[selectednum].dir==DIR_UPRIGHT))&&(testmove[0]==true)&&(heros[selectednum].walking)&&(heros[selectednum].y-heros[selectednum].speed>0)){heros[selectednum].y-=heros[selectednum].speed;if((camy-heros[selectednum].speed>0)&&(heros[selectednum].y-camy<170))camy-=heros[selectednum].speed;}
  if(((heros[selectednum].dir==DIR_DOWN)||(heros[selectednum].dir==DIR_DOWNLEFT)||(heros[selectednum].dir==DIR_DOWNRIGHT))&&(testmove[1]==false)&&(ay!=-1)){heros[selectednum].y=ay;}
  if(((heros[selectednum].dir==DIR_UP)||(heros[selectednum].dir==DIR_UPLEFT)||(heros[selectednum].dir==DIR_UPRIGHT))&&(testmove[0]==false)&&(ah!=-1)){heros[selectednum].y=ah;}
  if(((heros[selectednum].dir==DIR_LEFT)||(heros[selectednum].dir==DIR_UPLEFT)||(heros[selectednum].dir==DIR_DOWNLEFT))&&(testmove[2]==false)&&(aw!=-1)){heros[selectednum].x=aw;}
  if(((heros[selectednum].dir==DIR_RIGHT)||(heros[selectednum].dir==DIR_DOWNRIGHT)||(heros[selectednum].dir==DIR_UPRIGHT))&&(testmove[3]==false)&&(ax!=-1)){heros[selectednum].x=ax;}
  if((!keys[40])&&(!keys[39])&&(!keys[37])&&(!keys[38])){heros[selectednum].walking=false;}
  else{heros[selectednum].walking=true;} //if an arrow key is pressed the heros[selectednum] is logged as walking

  //if they stepped on a hot spot
  for(int n=0;n<numofhotspots;n++)
  {
   bool test=hotspots[n].checkhit(&heros[selectednum]);
   if(!test)
   {
    heros[selectednum].x=hotspots[n].warpx;
    heros[selectednum].y=hotspots[n].warpy;
    camx=hotspots[n].warpx-310;
    camy=hotspots[n].warpy-200;
    heros[selectednum].mapindex=hotspots[n].mapnum;
    if(readinlvl(indexofmaps[hotspots[n].mapnum])!=0)
     {
      MessageBox(hWnd,"Error reading in a map.  Be sure this was correctly installed!","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
      quitting();
     }



    if(camx+640>levlsize.cx)camx=levlsize.cx-640;
    if(camy+380>levlsize.cy)camy=levlsize.cy-380;
    if(camx<0)camx=0;
    if(camy<0)camy=0;
    break;
   }
  }

//set up drawing surfaces
  HDC backtemp=CreateCompatibleDC(maindc); //temp background .bmp storage
  SelectObject(backtemp,backgrnd);
  HDC other=CreateCompatibleDC(maindc);  //other surface for double-buffering
  HBITMAP tempbmp=CreateCompatibleBitmap(maindc,640,380);
  SelectObject(other,tempbmp);
  BitBlt(other,0,0,640,380,backtemp,camx,camy,SRCCOPY);

  //draw all sprites and stuff
  heros[selectednum].heartbeat();
   for(int n=0;n<15;n++)
   {
    bool ifit=false;
    if(n==IT)ifit=true;
    if((heros[n].exists)&&(heros[n].mapindex==heros[selectednum].mapindex))heros[n].Draw(other,camx,camy,ifit);
    if((n!=selectednum)&&(heros[n].walking)&&(heros[n].exists))
    {
        bool testmove[4]={true,true,true,true};
/*        bool *tempmove;
        int ax=-1;
        int ay=-1;
        int aw=-1;
        int ah=-1;
        for(int m=0;m<numofblocks;m++)
        {
         if((heros[n].x+heros[n].width+(blocks[m].height*2)>=blocks[m].x)&&(heros[n].x-(2*blocks[m].height)<blocks[m].x+blocks[m].width))
         {
          tempmove=blocks[n].checkhit(&heros[n]);
          if(!tempmove[0]){testmove[0]=false;if(blocks[m].type==1)ah=blocks[m].y+blocks[m].height-heros[n].height+1;}
          if(!tempmove[1]){testmove[1]=false;if(blocks[m].type==1)ay=blocks[m].y-heros[n].height-1;}
          if(!tempmove[2]){testmove[2]=false;if(blocks[m].type==1)aw=blocks[m].x+blocks[m].width+1;}
          if(!tempmove[3]){testmove[3]=false;if(blocks[m].type==1)ax=blocks[m].x-heros[n].width-1;}
         }
        }*/

       if(((heros[n].dir==DIR_DOWN)||(heros[n].dir==DIR_DOWNLEFT)||(heros[n].dir==DIR_DOWNRIGHT))&&(testmove[1]==true)&&(heros[n].walking)&&(heros[n].y+heros[n].height+heros[n].speed<levlsize.cy)){heros[n].y+=heros[n].speed;}
       if(((heros[n].dir==DIR_RIGHT)||(heros[n].dir==DIR_DOWNRIGHT)||(heros[n].dir==DIR_UPRIGHT))&&(testmove[3]==true)&&(heros[n].walking)&&(heros[n].x+heros[n].width+heros[n].speed<levlsize.cx)){heros[n].x+=heros[n].speed;}
       if(((heros[n].dir==DIR_LEFT)||(heros[n].dir==DIR_DOWNLEFT)||(heros[n].dir==DIR_UPLEFT))&&(testmove[2]==true)&&(heros[n].walking)&&(heros[n].x-heros[n].speed>0)){heros[n].x-=heros[n].speed;}
       if(((heros[n].dir==DIR_UP)||(heros[n].dir==DIR_UPLEFT)||(heros[n].dir==DIR_UPRIGHT))&&(testmove[0]==true)&&(heros[n].walking)&&(heros[n].y-heros[n].speed>0)){heros[n].y-=heros[n].speed;}
/*       if(((heros[n].dir==DIR_DOWN)||(heros[n].dir==DIR_DOWNLEFT)||(heros[n].dir==DIR_DOWNRIGHT))&&(testmove[1]==false)&&(ay!=-1)){heros[n].y=ay;}
       if(((heros[n].dir==DIR_UP)||(heros[n].dir==DIR_UPLEFT)||(heros[n].dir==DIR_UPRIGHT))&&(testmove[0]==false)&&(ah!=-1)){heros[n].y=ah;}
       if(((heros[n].dir==DIR_LEFT)||(heros[n].dir==DIR_UPLEFT)||(heros[n].dir==DIR_DOWNLEFT))&&(testmove[2]==false)&&(aw!=-1)){heros[n].x=aw;}
       if(((heros[n].dir==DIR_RIGHT)||(heros[n].dir==DIR_DOWNRIGHT)||(heros[n].dir==DIR_UPRIGHT))&&(testmove[3]==false)&&(ax!=-1)){heros[n].x=ax;}*/
    }
   }

   for(int n=0;n<3;n++)
   {
    if((shots[n].dir<2)&&(heros[selectednum].mapindex==heros[IT].mapindex))
    {
    shots[n].Draw(other,camx,camy,false);
    if(shots[n].dir==1){shots[n].dir=0;}else{shots[n].dir=1;}
    }
   }

//   Rectangle(other,radarspot.cx,radarspot.cy,radarspot.cx+radarsize.cx,radarspot.cy+radarsize.cy);

   HDC radardc=CreateCompatibleDC(maindc);
   SelectObject(radardc,radar);
   StretchBlt(other,radarspot.cx,radarspot.cy,radarsize.cx,radarsize.cy,radardc,0,0,75,60,SRCCOPY);
   DeleteDC(radardc);

   if(flicker>3)SelectObject(other,pen1);
   if(flicker<3)SelectObject(other,pen2);
   if(flicker>7)flicker=0;
   for(int n=0;n<15;n++)
   {
    if((heros[n].exists)&&(heros[selectednum].mapindex==heros[n].mapindex)){MoveToEx(other,radarspot.cx+(heros[n].x+1)/20,radarspot.cy+(heros[n].y+1)/20,NULL);LineTo(other,radarspot.cx+((heros[n].x+1)/20)+1,radarspot.cy+((heros[n].y+1)/20));}
   }
   if(flicker>3)SetBkMode(other,OPAQUE);
//  if(flicker>3)SetTextColor(other,RGB(255,255,255));
//  TextOut(other,0,0,strings[0],strlen(strings[0]));
//  TextOut(other,0,15,strings[1],strlen(strings[1]));
//  TextOut(other,0,30,strings[2],strlen(strings[2]));
//  TextOut(other,0,45,strings[3],strlen(strings[3]));
  RECT rect;rect.left=0;rect.top=0;rect.right=630;rect.bottom=140;
  DrawText(other,strings[0],strlen(strings[0]),&rect,DT_LEFT|DT_WORDBREAK);
  rect.top=30;
  DrawText(other,strings[1],strlen(strings[1]),&rect,DT_LEFT|DT_WORDBREAK);
  rect.top=60;
  DrawText(other,strings[2],strlen(strings[2]),&rect,DT_LEFT|DT_WORDBREAK);
  rect.top=90;
  DrawText(other,strings[3],strlen(strings[3]),&rect,DT_LEFT|DT_WORDBREAK);

  BitBlt(maindc,0,0,640,380,other,0,0,SRCCOPY);  //copy buffer surface to actual surface

  //clean-up
  DeleteDC(other);
  DeleteObject(tempbmp);
  DeleteDC(backtemp);
//  if(connected)_beginthread(sendinfo,0,NULL);
}

int readinlvl(char *filename)
{
ifstream *ifs=new ifstream(filename,ios::in|ios::binary);
if(*ifs)
 {
 char *bmpfile=new char[100];
 ifs->seekg(0,ios::beg);
 BYTE numoflet=0;
 ifs->read((char*)&numoflet,1);
 ifs->read(bmpfile,numoflet);
 bmpfile[numoflet]='\0';
 char *yadda="images\\bg\\";
 char *line=new char[100];
 strcpy(line,yadda);
 strcat(line,bmpfile);
 DeleteObject(backgrnd);
 HBITMAP temp=LoadDDB(line,maindc,&backpal,&levlsize); //load in level bitmap;
  if(temp==NULL)
  {
   ReleaseDC(hWnd,maindc);
   DeleteObject(temp);
   MessageBox(hWnd,"Could not find a .bmp.  Please be sure this was installed correctly.","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
   quitting();
   return 1;
  }

//stretching background to be full sized
 backgrnd=CreateCompatibleBitmap(maindc,levlsize.cx*2,levlsize.cy*2);
 HDC other=CreateCompatibleDC(maindc);
 SelectObject(other,backgrnd);
 HDC tempdc=CreateCompatibleDC(maindc);
 SelectObject(tempdc,temp);
 StretchBlt(other,0,0,levlsize.cx*2,levlsize.cy*2,tempdc,0,0,levlsize.cx,levlsize.cy,SRCCOPY);
 levlsize.cx=levlsize.cx*2;
 levlsize.cy=levlsize.cy*2;
 radarsize.cx=levlsize.cx/20;
 radarsize.cy=levlsize.cy/20;
 radarspot.cx=640-radarsize.cx-20;
 radarspot.cy=380-radarsize.cy-20;


//cleanup
 DeleteDC(other);
 DeleteDC(tempdc);
 DeleteObject(temp);
 delete bmpfile;
 delete line;

 //read in rest of mapfile
 ifs->seekg(numoflet+2,ios::beg);
 ifs->read((char*)&numofblocks,2);
 ifs->read((char*)&numofhotspots,1);

 blocks=new BLOCK[numofblocks];
 hotspots=new HOTSPOT[numofhotspots];
 for(int n=0;n<numofblocks;n++)
 {
 ifs->read((char*)&blocks[n],sizeof(BLOCK));
 }
 for(int n=0;n<numofhotspots;n++)
 {
 ifs->read((char*)&hotspots[n],sizeof(HOTSPOT));
 }

 ifs->close();
 delete ifs;
 return 0;
 }
ifs->close();
delete ifs;
return 1;
}


void connect(void)
{
   sock=socket(AF_INET,SOCK_STREAM,0);
    if (sock == INVALID_SOCKET)
    {
     MessageBox(NULL, "Big fat winsock error!!!", "Error on socket()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
     quitting();
    }

   char *words="Trying to connect...";
   SendMessage(memo1,WM_SETTEXT,0,(LPARAM)words);
   addy.sin_family=AF_INET;
   addy.sin_port=htons(16738);
   char buffr[19];
   GetWindowText(edit1,buffr,19);
   addy.sin_addr.s_addr=inet_addr(buffr);
   SetWindowText(hWnd,buffr);
   _beginthread(connecting,0,NULL);
}

void connecting(void *thread)
{
    int test=connect(sock,(sockaddr*)&addy,sizeof(sockaddr_in));
    if(test!=0)
    {
    int errchk=WSAGetLastError();
    if(errchk==WSAECONNREFUSED){MessageBox(NULL, "Connection Refused!!!  Make sure it's a valid server.", "Error on connect()", MB_OK|MB_APPLMODAL|MB_TOPMOST);}
    else{MessageBox(NULL, "Big fat winsock error!!!", "Error on connect()", MB_OK|MB_APPLMODAL|MB_TOPMOST);}
    SetWindowText(memo1,"Could not connect.");
    closesocket(sock);
    _endthread();
    return;
    }
    SetWindowText(memo1,"Host found!");
    char *buffr=new char[200];
    int num=recv(sock,buffr,200,NULL);
    if(num==0)
     {
      SetWindowText(memo1,"Disconnected");
      closesocket(sock);
      _endthread();
      return;
     }
    if(num==SOCKET_ERROR)
     {
      SetWindowText(memo1,"Disconnected");
      closesocket(sock);
      _endthread();
      return;
     }
    if(buffr[0]=='!')
     {
     SetWindowText(memo1,"Too many users on server");
     closesocket(sock);
     _endthread();
     return;
     }

    selectednum=buffr[0];
    for(int n=0;n<15;n++)
    {
 //    buffr[(n*10)+11]='\0';
     if(n!=selectednum)memcpy(heros[n].name,&buffr[(n*10)+1],10);
     heros[n].exists=false;
    }
    for(int n=0;n<15;n++)
    {
     if(selectednum!=n)
     {
      heros[n].chosenchar=buffr[(10*15)+n+1];
      if((heros[n].chosenchar>0)&&(heros[n].chosenchar<6))heros[n].pict=LoadDDB(bmpfiles[heros[n].chosenchar-1],maindc,&heros[n].hpal,size);
      if(heros[n].pict==NULL)
      {
       MessageBox(hWnd,"Could not find a .bmp.  Please be sure this was installed correctly.","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
       quitting();
       exit(0);
      }
     }
    }
     //heros[1].name[9]='\0';
   // strcpy(heros[0].name,(char*)buffr[1]);
    heros[selectednum].exists=true;
    int temp=GetWindowText(memo2,heros[selectednum].name,10);
    heros[selectednum].name[temp]='\0';
    SetWindowText(hWnd,heros[selectednum].name);
    BYTE sendone[11];
    sendone[0]=1;
for(int j=0;j<5;j++)
{
    if(SendMessage(radio[j],BM_GETCHECK,0,0)==BST_CHECKED)
    {
    sendone[0]=j+1;
    heros[selectednum].chosenchar=j+1;
    break;
    }
}
    heros[selectednum].pict=LoadDDB(bmpfiles[heros[selectednum].chosenchar-1],maindc,&heros[selectednum].hpal,size);
    if(heros[selectednum].pict==NULL)heros[selectednum].pict=LoadDDB(bmpfiles[0],maindc,&heros[selectednum].hpal,size);
    strcpy((char*)&sendone[1],heros[selectednum].name);
     int check=send(sock,(char*)&sendone,10,NULL);
     if(check==SOCKET_ERROR)
     {
      connected=false;
      SetWindowText(memo1,"Error sending.  Connection lost.");
      closesocket(sock);
      _endthread();
      return;
     }


   switch(selectednum)
   {
    case 0:{heros[selectednum].x=350;heros[selectednum].y=200;break;}
    case 1:{heros[selectednum].x=1100;heros[selectednum].y=230;break;}
    case 2:{heros[selectednum].x=1600;heros[selectednum].y=200;break;}
    case 3:{heros[selectednum].x=500;heros[selectednum].y=500;break;}
    case 4:{heros[selectednum].x=310;heros[selectednum].y=820;break;}
    case 5:{heros[selectednum].x=1050;heros[selectednum].y=800;break;}
    case 6:{heros[selectednum].x=1750;heros[selectednum].y=830;break;}
    case 7:{heros[selectednum].x=400;heros[selectednum].y=1300;break;}
    case 8:{heros[selectednum].x=1000;heros[selectednum].y=1430;break;}
    case 9:{heros[selectednum].x=1275;heros[selectednum].y=1350;break;}
    case 10:{heros[selectednum].x=1500;heros[selectednum].y=1100;break;}
    case 11:{heros[selectednum].x=310;heros[selectednum].y=500;break;}
    case 12:{heros[selectednum].x=690;heros[selectednum].y=1025;break;}
    case 13:{heros[selectednum].x=1180;heros[selectednum].y=600;break;}
    case 14:{heros[selectednum].x=1800;heros[selectednum].y=200;break;}
   }
   camx=heros[selectednum].x-310;
   camy=heros[selectednum].y-200;

   connected=true;
   _beginthread(recvloop,0,NULL);
_endthread();
}



void recvloop(void *thread)  //loop for receiving stuff.
{
 while(connected)
 {
  char *buffr=new char[200];
  int num=recv(sock,buffr,200,NULL);
  if(num==0)
  {
   connected=false;
   SetWindowText(memo1,"Server disconnected");
   SetWindowText(memo2,"");
   SetWindowText(memo3,"");
   _endthread();
   return;
  }

  if(num==SOCKET_ERROR)
  {
   connected=false;
   SetWindowText(memo1,"Error reaching server.  (Server disconnected?)");
   SetWindowText(memo2,"");
   SetWindowText(memo3,"");
   _endthread();
   return;
  }


    switch(buffr[0]) //different types of sends from server
    {
     case 1:   //if a heros[] position/status update
     {
      if(((IT==selectednum)||(buffr[1]==selectednum))&&(buffr[1]!=IT))PlaySound("sounds\\Whop2.wav",NULL,SND_FILENAME|SND_ASYNC);
      IT=buffr[1];
      for(int n=0;n<15;n++)
      {
       if(n!=selectednum)
       {
        WORD *wordpntr=(WORD*)&buffr[2+n*6];
        heros[n].x=*wordpntr;
        wordpntr=(WORD*)&buffr[4+n*6];
        heros[n].y=*wordpntr;
        heros[n].mapindex=(buffr[6+n*6]>>4);
        heros[n].dir=(buffr[6+n*6]<<4);
        heros[n].dir=(heros[n].dir>>4)&15;
        char blah=buffr[7+n*6];
        if(blah==0)heros[n].exists=false;
        if(blah==1){heros[n].stepping=false;heros[n].exists=true;heros[n].walking=false;}
        if(blah==2){heros[n].stepping=false;heros[n].exists=true;heros[n].walking=true;}
        if(blah==3){heros[n].stepping=true;heros[n].exists=true;heros[n].walking=true;}
       }
       }
         for(int n=0;n<3;n++)
         {
         WORD *wordpntr=(WORD*)&buffr[92+n*5];
         shots[n].x=*wordpntr;
         wordpntr=(WORD*)&buffr[94+n*5];
         shots[n].y=*wordpntr;
         shots[n].dir=buffr[96+n*5];
         }
     break;
     }

     case 2: //if a message
     {
       switch(buffr[1]) //what kind of message?
       {
        case 1:  //kick message
        {
         if(buffr[2]==selectednum)
         {
          connected=false;
          closesocket(sock);
         }
         char *storage=new char[25];
         strcpy(storage,heros[buffr[2]].name);
         char *text=" was kicked!";
         strcat(storage,text);
         SetWindowText(memo1,storage);
         delete storage;
         break;
        }
        case 2:  //join message
        {
         int itemp=buffr[2];
         if(itemp!=selectednum)
        {
          strcpy(heros[itemp].name,(char*)&buffr[3]);
          heros[itemp].chosenchar=buffr[13];
         if((heros[itemp].chosenchar>0)&&(heros[itemp].chosenchar<6))heros[itemp].pict=LoadDDB(bmpfiles[heros[itemp].chosenchar-1],maindc,&heros[itemp].hpal,size);
         if(heros[itemp].pict==NULL)heros[itemp].pict=LoadDDB(bmpfiles[0],maindc,&heros[itemp].hpal,size);
         if(heros[itemp].pict==NULL)
         {
          MessageBox(hWnd,"Error reading.  Please be sure this was installed correctly.","Seek and Tag error",MB_OK|MB_ICONSTOP|MB_DEFBUTTON1|MB_APPLMODAL);
          quitting();
          exit(0);
         }

          char *storage=new char[25];
          strcpy(storage,heros[itemp].name);
          char *text=" has joined!!!";
          strcat(storage,text);
          SetWindowText(memo1,storage);
          delete storage;
         }
         break;
         }

         case 3:
         {
         char *storage=new char[250];
         strcpy(storage,heros[buffr[2]].name);
         char *tempy=":&> ";
         strcat(storage,tempy);
         char *text=&buffr[3];
         buffr[199]='\0';
         strcat(storage,text);
         strcpy(strings[0],strings[1]);
         strcpy(strings[1],strings[2]);
         strcpy(strings[2],strings[3]);
         strcpy(strings[3],storage);
         delete storage;
         break;
         }
        }
       break;
      }

     case 3: //if speaking
     {
     break;
     }
   }

  if(chatrequest)
  {
   chatrequest=false;
   saystuff(NULL);
  }


  if(PSIrequest)
  {
   PSIrequest=false;
    PSIPACKET pack;
    pack.type=3;
    pack.dir=heros[selectednum].dir;
     if((selectednum==IT)&&(connected))
     {
      int checky=send(sock,(char*)&pack,2,NULL);
      if(checky==SOCKET_ERROR)
       {
       MessageBox(NULL, "Big fat winsock error on send()!!!!", "Error on send()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
       SetWindowText(memo1,"Error Sending info");
       connected=false;
       closesocket(sock);
       }
     }
  }


//sending information
if(buffr[0]==1)
{
 
 PACKET pack;
 pack.type=1;
 pack.x=heros[selectednum].x;
 pack.y=heros[selectednum].y;
 pack.indexdir=((heros[selectednum].mapindex<<4)|heros[selectednum].dir);
 if((!heros[selectednum].stepping)&&(!heros[selectednum].walking))pack.existstep=1;
 if((!heros[selectednum].stepping)&&(heros[selectednum].walking))pack.existstep=2;
 if((heros[selectednum].stepping))pack.existstep=3;
 if(connected)
 {
 int check=send(sock,(char*)&pack,7,NULL);
 if(check==SOCKET_ERROR)
  {
  MessageBox(NULL, "Big fat winsock error!!!", "Error on send()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
  SetWindowText(memo1,"Error Sending Info");
  connected=false;
  closesocket(sock);
  }
 }
}
delete buffr;
 }
}

void sendinfo(void *thread)  //type 1
{
 PACKET pack;
 pack.type=1;
 pack.x=heros[selectednum].x;
 pack.y=heros[selectednum].y;
 pack.indexdir=((heros[selectednum].mapindex<<4)|heros[selectednum].dir);
 if((!heros[selectednum].stepping)&&(!heros[selectednum].walking))pack.existstep=1;
 if((!heros[selectednum].stepping)&&(heros[selectednum].walking))pack.existstep=2;
 if((heros[selectednum].stepping))pack.existstep=3;
 if(connected)
 {
 int check=send(sock,(char*)&pack,7,NULL);
 if(check==SOCKET_ERROR)
  {
  MessageBox(NULL, "Big fat winsock error!!!", "Error on send()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
  SetWindowText(memo1,"Error Sending Info");
  connected=false;
  closesocket(sock);
  }
 }
}

void shootpsi(void *thread)   //type 3
{
PSIPACKET pack;
pack.type=3;
pack.dir=heros[selectednum].dir;
 if((selectednum==IT)&&(connected))
 {
  int checky=send(sock,(char*)&pack,2,NULL);
  if(checky==SOCKET_ERROR)
   {
   MessageBox(NULL, "Big fat winsock error on send()!!!!", "Error on send()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
   SetWindowText(memo1,"Error Sending info");
   connected=false;
   closesocket(sock);
   }
 }
_endthread();
}

void saystuff(void *thread)   //type 4
{
SAYPACKET pack;
pack.type=4;
int speaklen=GetWindowText(memo3,(char*)&pack.spoken,150);


 if(connected)
 {
  int checky=send(sock,(char*)&pack,250,NULL);
  if(checky==SOCKET_ERROR)
   {
   MessageBox(NULL, "Big fat winsock error on send()!!!!", "Error on send()", MB_OK|MB_APPLMODAL|MB_TOPMOST);
   SetWindowText(memo1,"Error Sending info");
   connected=false;
   closesocket(sock);
   }
 }
SetWindowText(memo3,"");
//delete pack.spoken;
}
